ClusterName={{ slurm_cluster_name }}

{# TEST - to be included in the slurm role #}
{% for ctl in slurm_controllers %}
SlurmctldHost={{ ctl }}
{% endfor %}

{% if slurm_srun_portrange is defined %}SrunPortRange={{slurm_srun_portrange}}
{%endif%}

AuthType=auth/munge
{% if slurm_version_ctl_across_cluster is version('21.08', '<') %}
CacheGroups=0
{% endif %}
CryptoType=crypto/munge
MailProg=/usr/bin/mail
MpiDefault=none
PrivateData=accounts,reservations
ProctrackType={{ slurm_ProctrackType }}
PropagateResourceLimitsExcept=ALL
ReturnToService=2                                                               # un noeud quitte l'état DOWN dès qu'il a une configuration valide (default=1)
SlurmctldPidFile={{ slurm_slurmctld_pid_file }}
SlurmctldPort=6817
{% if slurm_slurmd_pid_file is defined and slurm_slurmd_pid_file != "" %}SlurmdPidFile={{ slurm_slurmd_pid_file }}
{%endif%}
SlurmdPort=6818
SlurmdSpoolDir={{ slurm_slurmd_spool_dir }}
SlurmUser={{ slurm_user }}
SlurmdUser=root
StateSaveLocation={{ slurm_state_save_location }}
SwitchType=switch/none
TaskPlugin={{ slurm_task_plugin | default(slurm_taskplugin | default ('task/none')) }}
InactiveLimit=0
KillWait=30
{% if slurm_unkillablesteptimeout is defined %}UnkillableStepTimeout={{slurm_unkillablesteptimeout}}  # Kill job timeout (if exceeded, the compute node will be drained)
{%endif%}
MinJobAge=300                                                                   # temps de conservation des jobs en file après execution
SlurmctldTimeout=120
SlurmdTimeout=300
Waittime=0                                                                      # temps que srun attend avant de terminer les tâches secondaires après que la tâche principale se soit arrêtée
# FastSchedule=1                                                                # deprecated
SchedulerType=sched/backfill                                                    # le scheduler peut lancer des jobs de priorités moins élevées à condition
                                                                                # qu'ils ne diffèrent pas le lancements de jobs en attente mais de priorité
                                                                                # plus élevée (nécessite que les utilisateurs spécifient les limites de temps)
{% if slurm_version_ctl_across_cluster is version('21.08', '<') %}
SchedulerPort=7321
{% endif %}

{% if slurm_version_ctl_across_cluster is version('22.00', '<') %}
SelectType=select/cons_res                                                      # les ressources sont considérées comme des consommables
{% else %}
SelectType=select/cons_tres                                                      # les ressources sont considérées comme des consommables
{% endif %}

SelectTypeParameters={{ slurm_select_type_parameters | default(slurm_selecttypeparameters | default ('CR_CPU_Memory')) }}

{% if slurm_maxjobcount is defined %}MaxJobCount={{slurm_maxjobcount}}
{%endif%}
{% if slurm_maxarraysize is defined %}MaxArraySize={{slurm_maxarraysize}}
{%endif%}
{% if slurm_prioritydecayhalflife is defined %}PriorityDecayHalfLife={{slurm_prioritydecayhalflife}}
{%endif%}
{% if slurm_priorityusageresetperiod is defined %}PriorityUsageResetPeriod={{slurm_priorityusageresetperiod}}
{%endif%}
PriorityType=priority/multifactor
PriorityWeightAge = 6000000
PriorityWeightFairShare = 10000000
PriorityWeightJobSize = 5000000
PriorityWeightPartition = 10000000
PriorityWeightQOS = 0


AccountingStorageEnforce=limits
AccountingStorageHost={{ slurm_accounting_storage_host }}
AccountingStoragePort=6819
AccountingStorageType=accounting_storage/slurmdbd
AccountingStorageUser=root
{% if slurm_version_ctl_across_cluster is version('21.08', '>=') %}
AccountingStoreFlags=job_comment
{% else %}
AccountingStoreJobComment=YES
{%endif%}
DebugFlags=NO_CONF_HASH
JobCompType=jobcomp/none                                                        # none car stockage des données dans slurmdbd
JobAcctGatherFrequency=30
JobAcctGatherType=jobacct_gather/linux
SlurmctldDebug=debug
SlurmctldLogFile={{ slurm_log_dir }}/slurmctld.log
SlurmSchedLogFile={{ slurm_log_dir }}/sched.log
SlurmSchedLogLevel=1
SlurmdDebug={{slurm_log_level}}
SlurmdLogFile={{ slurm_log_dir }}/slurmd.log
DefMemPerCPU=2000
FirstJobId={{ first_job_id }}
{% if preempt_mode is defined %}PreemptMode = {{ preempt_mode }}
{%endif%}
{% if preempt_type is defined %}PreemptType = {{ preempt_type }}
{%endif%}

HealthCheckInterval={{ slurm_healthcheckinterval }}
HealthCheckProgram="{{ slurm_script_healthcheck_path }}"

Prolog={{slurm_config_dir}}/prolog
Epilog={{slurm_config_dir}}/epilog
TaskProlog={{slurm_config_dir}}/taskprolog
TaskEpilog={{slurm_config_dir}}/taskepilog

{% if gpu_nodes is defined and gpu_nodes %}
AccountingStorageTRES=gres/gpu
GresTypes=gpu
{%endif%}

SlurmdParameters=config_overrides       # can we remove this ?

NodeName={{ slurm_primary_controller }} State=UNKNOWN

{% for host in slurm_nodes_hosts %}
{% if "slurm_nodeinfo_mem" in hostvars[host] %}
{% set node_name = hostvars[host]["slurm_nodeinfo_name"]|default(host, true) -%}
{% set node_mem = hostvars[host]["slurm_nodeinfo_mem"] -%}
{% set node_real_memory = node_mem if slurm_enforce_spec else node_mem - slurm_node_memspeclimit -%}
{% set node_cpu = hostvars[host]["slurm_nodeinfo_cpu"] -%}
{% set node_core = hostvars[host]["slurm_nodeinfo_core"] -%}
{% set node_threads = hostvars[host]["slurm_nodeinfo_threads"] -%}
{% set node_cores_per_socket = node_core * node_threads if slurm_enforce_spec else ((node_core * node_threads) - (slurm_node_corespeccount/node_cpu))|int -%}
{% set node_weight = hostvars[host]["slurm_nodeinfo_weight"]|default('5') -%}
{% set node_gres = " Gres=" + hostvars[host]["slurm_nodeinfo_gres"] if hostvars[host]["slurm_nodeinfo_gres"] is defined else "" %}
{% set node_features = " Features=" + hostvars[host]["slurm_nodeinfo_features"] if hostvars[host]["slurm_nodeinfo_features"] is defined else "" %}
{% set node_tmpdisk = " TmpDisk=" + (hostvars[host]["slurm_nodeinfo_tmpsize"]-50) | string if hostvars[host]["slurm_nodeinfo_tmpsize"] is defined else "" %}
NodeName={{ node_name -}}
{{' '}}RealMemory={{ node_real_memory -}}
{{' '}}Sockets={{ node_cpu -}}
{{' '}}CoresPerSocket={{ [node_cores_per_socket,1]|max -}}
{{' '}}ThreadsPerCore=1{{ '' -}}
{% if slurm_enforce_spec  %}
{% if slurm_node_memspeclimit > 0 %} MemSpecLimit={{ slurm_node_memspeclimit -}}{% endif %}
{% if slurm_node_corespeccount > 0 %} CoreSpecCount={{ slurm_node_corespeccount -}}{% endif %}
{% endif %}
{{' '}}Weight={{ node_weight -}}
{{ node_gres -}}
{{ node_features -}}
{{' '}}State=UNKNOWN{{ '' -}}
{{ node_tmpdisk }}
{% else %}
# WARNING: Node {{ host }} is listed but no data is found ! Check hostvars !
{% endif %}
{% endfor %}

{% for partition in slurm_partitions %}
PartitionName={{partition.name}} Nodes={% if partition.nodes is defined %}"{{partition.nodes}}"{%else%}{{ groups[partition.nodes_group] | map('extract', hostvars, 'ansible_hostname')|join(',') }}{%endif%} Default={{partition.default}} MaxTime={{partition.max_time}} {% if partition.default_time is defined %}DefaultTime={{partition.default_time}} {% endif %}AllowAccounts={{partition.allow_accounts}} {% if partition.deny_qos is defined %}DenyQos={{ partition.deny_qos }} {% endif %}State={{partition.state}}
{% endfor %}
